# DE2-115-FPGA-Pong

Pong game on Altera FPGA as exercise in Hardware-/Software-Codesign
[![](images/video.jpeg)](images/video.mp4)

## Data flow
![](images/data_graph.png)

## Flowcharts of the VHDL program

### Multiplex process
![](images/matrix_multiplex.png)

### Debounce process
![](images/button_debounce.png)

## Flowcharts of the C program
Below images show flowcharts for all featured software functions.
Fist chart feature the main game function. Subfunctions are described below.
See:    
- [draw](images/draw.png)
- [reset_positons](images/reset_positions.png)
- [reset_screen](images/reset_screen.png)

### Main function Flowchart
![](images/game_function_PAP.png)

---

### Subfunctions Flowcharts
Flowchart of draw function. Function output the virtual screen to the output pins to be processed by VHDL

![](images/draw.png)

---

Flowchart of reset_position function.
Function to reset positions of both paddles and ball to default. 
Default positions and values can be adjusted in this function

![](images/reset_positions.png)

---

Flowchart of reset_screen function.
Function to reset all pixels of the virtual screen to 0.

![](images/reset_screen.png)